config/urls.py
from django.conf import settings
from django.conf.urls import url, include

from django.contrib import admin
from django.contrib.auth.views import logout
from django.views.generic import TemplateView

# Import feeds
import core.views
from events.feeds import EventFeed, feedview
import events.reports
import events.views
from ligoauth.views import pre_login, post_login, shib_logout, manage_password
import search.views

# Django admin auto-discover
admin.autodiscover()

feeds = {
    'latest' : EventFeed
}


urlpatterns = [
    url(r'^$', events.views.index, name="home"),
    url(r'^navbar_only$', TemplateView.as_view(
        template_name='navbar_only.html'), name="navbar-only"),
    url(r'^SPInfo', TemplateView.as_view(template_name='gracedb/spinfo.html'),
         name="spinfo"),
    url(r'^SPPrivacy', TemplateView.as_view(
        template_name='gracedb/spprivacy.html'), name="spprivacy"),
    url(r'^DiscoveryService', TemplateView.as_view(
        template_name='discovery.html'), name="discovery"),
    url(r'^events/', include('events.urls')),
    url(r'^superevents/', include('superevents.urls')),
    url(r'^alerts/', include('alerts.urls')),
    url(r'^feeds/(?P<url>.*)/$', EventFeed()),
    url(r'^feeds/$', feedview, name="feeds"),

    url(r'^performance/$', events.views.performance, name="performance"),
    url(r'^reports/$', events.reports.histo, name="reports"),
    url(r'^reports/cbc_report/(?P<format>(json|flex))?$',
        events.reports.cbc_report, name="cbc_report"),
    url(r'^latest/$', search.views.latest, name="latest"),
    #(r'^reports/(?P<path>.+)$', 'django.views.static.serve',
    #        {'document_root': settings.LATENCY_REPORT_DEST_DIR}),
    url(r'^search/$', search.views.search, name="mainsearch"),

    # Authentication
    url(r'^login/$', pre_login, name='login'),
    url(r'^post-login/$', post_login, name='post-login'),
    url(r'^logout/$', shib_logout, name='logout'),

    # Password management
    url('^manage-password/$', manage_password, name='manage-password'),

    # API URLs
    url(r'^api/', include('api.urls')),
    # Legacy API URLs - must be maintained!
    url(r'^apibasic/', include('api.urls', namespace='legacy_apibasic')),
    url(r'^apiweb/', include('api.urls', namespace='legacy_apiweb')),

    # Heartbeat URL
    url(r'^heartbeat/$', core.views.heartbeat, name='heartbeat'),

    # Uncomment the admin/doc line below and add 'django.contrib.admindocs'
    # to INSTALLED_APPS to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),
    url(r'^admin/', admin.site.urls),

    # sessions
    #url(r'', include('user_sessions.urls', 'user_sessions')),

]

# We don't require settings.DEBUG for django-silk since running unit tests
# by default setings settings.DEBUG to False, unless you use the
# --debug-mode flag
if ('silk' in settings.INSTALLED_APPS):
    # Add django-silk
    urlpatterns = [
        url(r'^silk/', include('silk.urls', namespace='silk'))
    ] + urlpatterns

# Add django-debug-toolbar
if settings.DEBUG and 'debug_toolbar' in settings.INSTALLED_APPS:
    import debug_toolbar
    urlpatterns = [
        url(r'^__debug__/', include(debug_toolbar.urls)),
    ] + urlpatterns

gracedb/alerts/urls.py
from django.conf.urls import url

from . import views

app_name = 'alerts'


urlpatterns = [
    # Base /options/ URL
    url(r'^$', views.index, name="index"),

    # Contacts
    url(r'^contact/create/', views.CreateContactView.as_view(),
        name='create-contact'),
    url(r'^contact/(?P<pk>\d+)/edit/$', views.EditContactView.as_view(),
        name="edit-contact"),
    url(r'^contact/(?P<pk>\d+)/delete/$', views.DeleteContactView.as_view(),
        name="delete-contact"),
    url(r'^contact/(?P<pk>\d+)/test/$', views.TestContactView.as_view(),
        name="test-contact"),
    url(r'^contact/(?P<pk>\d+)/request-code/$',
        views.RequestVerificationCodeView.as_view(),
        name="request-verification-code"),
    url(r'^contact/(?P<pk>\d+)/verify/$', views.VerifyContactView.as_view(),
        name="verify-contact"),

    # Notifications
    url(r'^notification/create/$', views.CreateNotificationView.as_view(),
        name="create-notification"),
    url(r'^notification/(?P<pk>\d+)/edit/$',
        views.EditNotificationView.as_view(), name="edit-notification"),
    url(r'^notification/(?P<pk>\d+)/delete/$',
        views.DeleteNotificationView.as_view(), name="delete-notification"),
]

gracedb/api/urls.py
from django.conf.urls import url, include

app_name = 'api'

urlpatterns = [
    url(r'^', include('api.v1.urls', namespace='default')),
    url(r'^v1/', include('api.v1.urls', namespace='v1')),
    url(r'^v2/', include('api.v2.urls', namespace='v2')),
]

gracedb/core/urls.py
# URL utilities

from django.contrib.sites.models import Site


def build_absolute_uri(relative_uri, request=None):
    if request is not None:
        return request.build_absolute_uri(relative_uri)
    else:
        # Assume HTTPS
        domain = Site.objects.get_current().domain
        return 'https://' + domain + relative_uri

gracedb/superevents/urls.py
from django.conf.urls import url, include
from .models import Superevent
from . import views

app_name = 'superevents'


# URLs which are nested below a superevent detail
# These are included under a superevent's ID URL prefix (see below)
suburlpatterns = [

    # Superevent detail view
    url(r'^view/$', views.SupereventDetailView.as_view(), name="view"),

    # File list (file detail/download is handled through the API)
    url(r'^files/$', views.SupereventFileList.as_view(), name="file-list"),
]

# Legacy URL patterns - don't really need them, but we use them for the
# convenience of users who may be accustomed to the legacy event URL patterns
legacy_urlpatterns = [
    # Legacy URLs for superevent detail view
    url(r'^(?P<superevent_id>{regex})/$'.format(
        regex=Superevent.ID_REGEX), views.SupereventDetailView.as_view(),
        name="legacyview1"),
    url(r'^view/(?P<superevent_id>{regex})/$'.format(
        regex=Superevent.ID_REGEX), views.SupereventDetailView.as_view(),
        name="legacyview2"),
]

# Full urlpatterns: legacy urls plus suburlpatterns nested under
# superevent_id
urlpatterns = legacy_urlpatterns + [
    url(r'^(?P<superevent_id>{regex})/'.format(regex=Superevent.ID_REGEX),
        include(suburlpatterns)),
]

gracedb/alerts/models.py
from collections import defaultdict
import logging
import random
import textwrap

from django.conf import settings
from django.contrib.auth import get_user_model
from django.core.exceptions import ValidationError, NON_FIELD_ERRORS
from django.core.mail import EmailMessage
from django.db import models
from django.utils import timezone
from django.utils.http import urlencode

from django_twilio.client import twilio_client

from core.models import CleanSaveModel
from .fields import PhoneNumberField
from .phone import get_twilio_from


# Set up logger
logger = logging.getLogger(__name__)

# Set up user model
UserModel = get_user_model()

###############################################################################
# Contacts ####################################################################
###############################################################################
class Contact(CleanSaveModel):
    # Phone contact methods
    CONTACT_PHONE_CALL = 'C'
    CONTACT_PHONE_TEXT = 'T'
    CONTACT_PHONE_BOTH = 'B'
    CONTACT_PHONE_METHODS = (
        (CONTACT_PHONE_CALL, 'Call'),
        (CONTACT_PHONE_TEXT, 'Text'),
        (CONTACT_PHONE_BOTH, 'Call and text'),
    )
    # Number of digits in verification codes
    CODE_DIGITS = 6

    # Fields
    user = models.ForeignKey(UserModel, null=False)
    description = models.CharField(max_length=30, blank=False, null=False)
    email = models.EmailField(blank=True, null=True)
    phone = PhoneNumberField(blank=True, max_length=255, null=True)
    phone_method = models.CharField(max_length=1, null=True, blank=True,
        choices=CONTACT_PHONE_METHODS, default=None)
    verified = models.BooleanField(default=False, editable=False)
    verification_code = models.IntegerField(null=True, editable=False)
    verification_expiration = models.DateTimeField(null=True, editable=False)


    def __str__(self):
        return "{0}: {1}".format(self.user.username, self.description)

    def clean(self):
        # Mostly used for preventing creation of bad Contact
        # objects through the Django interface.
        super(Contact, self).clean()

        err_dict = defaultdict(list)
        # If a phone number is given, require either call or text to be True.
        if (self.phone is not None and self.phone_method is None):
            err_msg = 'Choose a phone contact method.'
            err_dict['phone_method'].append(err_msg)

        if (self.phone is None and self.phone_method is not None):
            err_msg = '"Call" and "text" should be False for non-phone alerts.'
            err_dict['phone'].append(err_msg)

        # Only one contact method is allowed
        if (self.email is not None and self.phone is not None):
            err_msg = \
                'Only one contact method (email or phone) can be selected.'
            err_dict[NON_FIELD_ERRORS].append(err_msg)

        # If no e-mail or phone given, raise error.
        # We have to skip this due to really annoying behavior with forms.. :(
        #if not (self.email or self.phone):
        #    err_msg = \
        #        'One contact method (email or phone) is required.'
        #    err_dict[NON_FIELD_ERRORS].append(err_msg)

        if err_dict:
            raise ValidationError(err_dict)

    def generate_verification_code(self):
        self.verification_code = random.randint(10**(self.CODE_DIGITS-1),
            (10**self.CODE_DIGITS)-1)
        self.verification_expiration = timezone.now() + \
            settings.VERIFICATION_CODE_LIFETIME
        self.save(update_fields=['verification_code',
            'verification_expiration'])

    def send_verification_code(self):
        # Message for texts and emails
        msg = ('Verification code for contact "{desc}" on {host}: {code}. '
            'If you did not request a verification code or do not know what '
            'this is, please disregard.').format(desc=self.description,
            host=settings.LIGO_FQDN, code=self.verification_code)

        if self.email:
            subject = 'Verification code for contact "{desc}" on {host}' \
                .format(desc=self.description, host=settings.LIGO_FQDN)
            email = EmailMessage(subject, msg,
                from_email=settings.ALERT_EMAIL_FROM, to=[self.email])
            email.send()
        elif self.phone:
            from_ = get_twilio_from()

            if (self.phone_method == self.CONTACT_PHONE_CALL):
                # If phone method is only call, send a call

                # Convert code to a string with spaces between the numbers
                # so it's pronounced properly by text-to-voice
                code = " ".join(str(self.verification_code))
                urlparams = urlencode({'code': code})
                twiml_url = '{base}{twiml_bin}?{params}'.format(
                    base=settings.TWIML_BASE_URL,
                    twiml_bin=settings.TWIML_BIN['verify'],
                    params=urlparams)
                twilio_client.calls.create(to=self.phone, from_=from_,
                    url=twiml_url, method='GET')
            else:
                # If method is text or both, send a text
                twilio_client.messages.create(to=self.phone, from_=from_,
                    body=msg)

    def verify(self):
        self.verified = True
        self.save(update_fields=['verified'])

    def display(self):
        if self.email:
            return "Email {0}".format(self.email)
        elif self.phone:
            if self.phone_method == self.CONTACT_PHONE_BOTH:
                return "Call and text {0}".format(self.phone)
            elif self.phone_method == self.CONTACT_PHONE_CALL:
                return "Call {0}".format(self.phone)
            if self.phone_method == self.CONTACT_PHONE_TEXT:
                return "Text {0}".format(self.phone)

    def print_info(self):
        """Prints information about Contact object; useful for debugging."""
        info_str = textwrap.dedent("""\
            Contact "{description}" (user {username})
            E-mail: {email}
            Phone: {phone} (method={method})
            Verified: {verified}
        """).format(description=self.description, username=self.user.username,
        email=self.email, phone=self.phone, method=self.phone_method,
        verified=self.verified)
        print(info_str)


###############################################################################
# Notifications ###############################################################
###############################################################################
class Notification(models.Model):
    # Notification categories
    NOTIFICATION_CATEGORY_EVENT = 'E'
    NOTIFICATION_CATEGORY_SUPEREVENT = 'S'
    NOTIFICATION_CATEGORY_CHOICES = (
        (NOTIFICATION_CATEGORY_EVENT, 'Event'),
        (NOTIFICATION_CATEGORY_SUPEREVENT, 'Superevent'),
    )
    user = models.ForeignKey(UserModel, null=False)
    contacts = models.ManyToManyField(Contact)
    description = models.CharField(max_length=40, blank=False, null=False)
    far_threshold = models.FloatField(blank=True, null=True)
    labels = models.ManyToManyField('events.label', blank=True)
    label_query = models.CharField(max_length=100, null=True, blank=True)
    category = models.CharField(max_length=1, null=False, blank=False,
        choices=NOTIFICATION_CATEGORY_CHOICES,
        default=NOTIFICATION_CATEGORY_SUPEREVENT)
    # Whether the event possibly has a neutron star in it.
    # The logic for determining this is defined in a method below.
    ns_candidate = models.BooleanField(default=False)
    # Event-only fields
    groups = models.ManyToManyField('events.group', blank=True)
    pipelines = models.ManyToManyField('events.pipeline', blank=True)
    searches = models.ManyToManyField('events.search', blank=True)

    def __unicode__(self):
        return (u"%s: %s") % (
            self.user.username,
            self.display()
        )

    def display(self):
        kwargs = {}
        if self.category == self.NOTIFICATION_CATEGORY_EVENT:
            output = 'Event'
        elif self.category == self.NOTIFICATION_CATEGORY_SUPEREVENT:
            output = 'Superevent'

        # Add label stuff
        if self.label_query or self.labels.exists():
            action = 'labeled with {labels}'
            if self.label_query:
                labels = '({0})'.format(self.label_query)
            else:
                labels = " & ".join([l.name for l in self.labels.all()])
                if self.labels.count() > 1:
                    labels = '({0})'.format(labels)
            action = action.format(labels=labels)
        else:
            if self.far_threshold or self.ns_candidate:
                action = 'created or updated'
            else:
                action = 'created'
        output += ' {action}'.format(action=action)

        # Add groups, pipelines, searches for event-type notifications
        if self.category == self.NOTIFICATION_CATEGORY_EVENT:
            output += ' & {groups} & {pipelines} & {searches}'
            if self.groups.exists():
                grps = " | ".join([g.name for g in self.groups.all()])
                if self.groups.count() > 1:
                    grps = '({0})'.format(grps)
                kwargs['groups'] = 'group={0}'.format(grps)
            else:
                kwargs['groups'] = 'any group'
            if self.pipelines.exists():
                pipelines = " | ".join([p.name for p in self.pipelines.all()])
                if self.pipelines.count() > 1:
                    pipelines = '({0})'.format(pipelines)
                kwargs['pipelines'] = 'pipeline={0}'.format(pipelines)
            else:
                kwargs['pipelines'] = 'any pipeline'
            if self.searches.exists():
                searches = " | ".join([s.name for s in self.searches.all()])
                if self.searches.count() > 1:
                    searches = '({0})'.format(searches)

gracedb/superevents/forms.py
import logging
import os

from django import forms

from superevents.models import Signoff

# Set up logger
logger = logging.getLogger(__name__)


class SignoffForm(forms.ModelForm):

    class Meta:
        model = Signoff
        fields = ['status', 'comment', 'signoff_type', 'instrument']

    def __init__(self, *args, **kwargs):
        super(SignoffForm, self).__init__(*args, **kwargs)
        # Hide some fields that we will populate either by default
        # when we instantiate the form or with the request data
        self.fields['signoff_type'].widget = forms.HiddenInput()
        self.fields['instrument'].widget = forms.HiddenInput()

gracedb/api/v2/events/views.py
from ...v1.events.views import *

gracedb/api/v2/main/views.py
from ...v1.main.views import *

gracedb/api/v2/superevents/views.py
from ...v1.superevents.views import *

gracedb/templates/superevents/detail.html
{% extends "base.html" %}
{% load sanitize_html %}
{% load logtags %}
{% block heading %}{% endblock %}
{% block bodyattrs %}class="tundra eventDetail"{% endblock %}

{% block jscript %}
{% load static %}
<link rel="stylesheet" href="{% static "css/labeltips.css" %}" />
<script src="{% static "moment/moment.js" %}"></script>
<script src="{% static "moment-timezone/builds/moment-timezone-with-data.min.js" %}"></script>
<script src="{% static "dojo/dojo.js" %}" data-dojo-config="async: true"></script>
<script src="{% static "jquery/dist/jquery.min.js" %}"></script>
<!-- Styles for dgrid -->
<!-- <link rel="stylesheet" href="{% static "dgrid/css/dgrid.css" %}" /> -->
<!-- Styles for the editor components -->
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/PageBreak.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/ShowBlockNodes.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/Preview.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/Save.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/Breadcrumb.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/FindReplace.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/PasteFromWord.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/InsertAnchor.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/CollapsibleToolbar.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/Blockquote.css" %}" />
<link rel="stylesheet" href="{% static "dojox/editor/plugins/resources/css/Smiley.css" %}" />
<!-- Styles for the lightboxes. --> 
<link rel="stylesheet" href="{% static "dojox/image/resources/LightboxNano.css" %}" />
<!-- Local style declarations -->
<link rel="stylesheet" href="{% static "dijit/themes/tundra/tundra.css" %}" />

<!-- the main JavaScript block is pulled in with an include -->
<script>
{% include "superevents/superevent_detail_script.js" %}
</script>

{% endblock %}

{% block content %}
<div id='event_detail_content'>

{% if superevent.is_exposed and not user_is_external %}
<!-- Show internal users that this superevent is publicly exposed -->
<h2 style="color: red; text-align: center;">PUBLIC SUPEREVENT</h2>
{% endif %}

{% if messages %}
<div class="flash">
    {% for m in messages %}
        <p>{{ m }}</p>
    {% endfor %}
</div>
{% endif %}

{% if show_gw_status_form %}
<div class="content-area">
<form action="{% url "legacy_apiweb:default:superevents:superevent-confirm-as-gw" superevent.superevent_id %}" method="POST" id="confirm_as_gw_form">
    <input type="submit" value="Confirm this superevent as a GW" class="permButtonClass" disabled>
</form>
<div><b>Note:</b> this action is irreversible without manual intervention by an admin.</div>
</div>
{% endif %}

{# not sure why we need this if statement, maybe can delete in the future #}
{% if 'lvem_view' not in request.path %}

{#-- XXX This next bit is super hacky. #}
{% if can_modify_permissions %}
<div class="content-area">
<form action="{% url "legacy_apiweb:default:superevents:superevent-permission-modify" superevent.superevent_id %}" method="POST" id="permissions_form">
    <input type="hidden" name="action" value="{{ permissions_action }}">
    <input type="submit" value="{{ permissions_form_button_text }}" class="permButtonClass" disabled>
</form>
</div>
{% endif %}

{% if operator_signoff_authorized and operator_signoff_active %}
<div class="signoff-area">
    <h2>{{ operator_signoff_instrument }} Operator Signoff</h2>
    <p>You are seeing this section because you've connected from a machine that, according to our records, is in the {{ signoff_instrument }} control room.</p>
    {% if operator_signoff_exists %}
    <p>This event has already been signed off on. Use the form below if you wish to edit or delete the record.</p>
    {% else %}
    <p>This superevent still requires operator signoff. Please answer the following (and optionally enter a comment): At the time of the superevent ({{ object_gpstime_in_operator_tz }}), was the operating status of the detector basically okay, or not?</p>
    {% endif %}
    <form class="signoff_form">
        <table>
        {{ operator_signoff_form.as_table }}
        <tr>
            <td></td>
            <td>
            {# inputs are disabled here, enabled by jquery code on page load. Otherwise users who click quickly can activate the form before the jquery is fully loaded #}
            {% if operator_signoff_exists %}
            {% with operator_signoff_type|add:operator_signoff_instrument as typeinst %}
                <input type="submit" formaction="{% url "legacy_apiweb:default:superevents:superevent-signoff-detail" superevent.superevent_id typeinst %}" value="Update signoff" class="searchButtonClass" id="update" disabled>
                <input type="submit" formaction="{% url "legacy_apiweb:default:superevents:superevent-signoff-detail" superevent.superevent_id typeinst %}" value="Delete signoff" class="searchButtonClass" id="delete" disabled>
            {% endwith %}
            {% else %}
            <input type="submit" value="Create signoff" class="searchButtonClass" formaction={% url "legacy_apiweb:default:superevents:superevent-signoff-list" superevent.superevent_id %} disabled>
            {% endif %}
            </td>
        </tr>
        </table>
    </form>
</div>
{% endif %}

{# Here is a section for the EM advocate signoffs. #}
{% if advocate_signoff_authorized and advocate_signoff_active %}
<div class="signoff-area">
    <h2>Advocate Signoff</h2>
    <p>You are seeing this section because you're a designated EM followup advocate.
    {% if advocate_signoff_exists %}
    This event has already been signed off on. Use the form below if you wish to edit or delete the record.
    {% else %}
    This event still requires EM Followup advocate signoff.
    {% endif %}
    </p>
    
    <form class="signoff_form">
        <table>
        {{ advocate_signoff_form.as_table }}
        <tr>
            <td></td>
            <td>
            {# inputs are disabled here, enabled by jquery code on page load. Otherwise users who click quickly can activate the form before the jquery is fully loaded #}
            {% if advocate_signoff_exists %}
            {% with advocate_signoff_type|add:advocate_signoff_instrument as typeinst %}
                <input type="submit" formaction="{% url "legacy_apiweb:default:superevents:superevent-signoff-detail" superevent.superevent_id typeinst %}" value="Update signoff" class="searchButtonClass" id="update" disabled>
                <input type="submit" formaction="{% url "legacy_apiweb:default:superevents:superevent-signoff-detail" superevent.superevent_id typeinst %}" value="Delete signoff" class="searchButtonClass" id="delete" disabled>
            {% endwith %}
            {% else %}
            <input type="submit" value="Create signoff" class="searchButtonClass" formaction={% url "legacy_apiweb:default:superevents:superevent-signoff-list" superevent.superevent_id %} disabled>
            {% endif %}
            </td>
        </tr>
        </table>
    </form>
</div>
{% endif %}

{% endif %} {# lvem_view not in request.path #}

<div class="content-area">
{% block superevent_info %}
<h2>Superevent Info</h2>
    {% if user.is_authenticated %}
        {% include "superevents/superevent_info_table.html" %}
    {% else %}
        {% include "superevents/superevent_info_table_public.html" %}
    {% endif %}
{% endblock %}

<br />
<br />

{% block basic_info %}
<h2>Preferred Event Info</h2>
    {% if user.is_authenticated %}
        {% include "superevents/preferred_event_info_table.html" %}
    {% else %}
        {% include "superevents/preferred_event_info_table_public.html" %}
    {% endif %}
{% endblock %}

{% if user.is_authenticated %}
{% include "superevents/emo_form_frag.html" %}
{% endif %}

</div> <!-- end event_detail_content div -->
{% endblock %}

gracedb/templates/superevents/superevent_info_table.html
{% load timeutil %}
<table class="superevent">
    <tr>
        <th>Superevent ID</th>
        {% if superevent.is_gw %}
        <th>GW ID</th>
        {% endif %}
        <th>Category</th>
        <th>Labels</th>
        <th>Preferred event</th>
        <th>GW events</th>
        <th>External events</th>
        <th>t_start</th>
        <th>t_0</th>
        <th>t_end</th>
        <th>
            <div id="superevent_created_ts"></div>
            <div>Submission time</div>
        </th>
        <th>Links</th>
    </tr>
    <tr>
        <td>{{ superevent.default_superevent_id }}</td>
        {% if superevent.is_gw %}
        <td>{{ superevent.gw_id }}</td>
        {% endif %}
        <td>{{ superevent.get_category_display }}</td>
        <td>
        {% for labelling in superevent.labelling_set.all %}
            <div onmouseover="tooltip.show(tooltiptext('{{labelling.label.name}}', '{{labelling.creator.username}}', '{{labelling.created|utc}}', '{{labelling.label.description}}'));" onmouseout="tooltip.hide();" style="color: {{labelling.label.defaultColor}};" class="label">
                {{ labelling.label.name }}
            </div>
       {% endfor %}
        </td>
        <td><a href="{% url "view" preferred_event.graceid %}">{{ preferred_event.graceid }}</a></td>
        <td>
            <div>
            {% for graceid in internal_events %}
            <a href="{% url "view" graceid %}">{{ graceid }}</a>
            {% endfor %}
            </div>
        </td>
        <td>
            <div>
            {% for graceid in external_events %}
            <a href="{% url "view" graceid %}">{{ graceid }}</a>
            {% endfor %}
            </div>
        </td>
        <td>{{ superevent.t_start }}</td>
        <td>{{ superevent.t_0 }}</td>
        <td>{{ superevent.t_end }}</td>
        <td>{{ superevent.created|multiTime:"superevent_created" }}</td>
        <td><a href="{% url "superevents:file-list" superevent.superevent_id %}">Data</a></td>
    </tr>
</table>

gracedb/templates/superevents/superevent_info_table_public.html
{% load timeutil %}
{% load scientific %}
<table class="superevent">
    <tr>
        <th>Superevent ID</th>
        {% if superevent.is_gw %}
        <th>GW ID</th>
        {% endif %}
        <th>Category</th>
        <th>Labels</th>
        <th>FAR (Hz)</th>
        <th>FAR (yr<sup>-1</sup>)</th>
        <th>t_start</th>
        <th>t_0</th>
        <th>t_end</th>
        <th>
            <div id="superevent_created_ts"></div>
            <div>Submission time</div>
        </th>
        <th>Links</th>
    </tr>
    <tr>
        <td>{{ superevent.default_superevent_id }}</td>
        {% if superevent.is_gw %}
        <td>{{ superevent.gw_id }}</td>
        {% endif %}
        <td>{{ superevent.get_category_display }}</td>
        <td>
        {% for labelling in superevent.labelling_set.all %}
            <div onmouseover="tooltip.show(tooltiptext('{{labelling.label.name}}', '{{labelling.creator.username}}', '{{labelling.created|utc}}', '{{labelling.label.description}}'));" onmouseout="tooltip.hide();" style="color: {{labelling.label.defaultColor}};" class="label">
                {{ labelling.label.name }}
            </div>
       {% endfor %}
        </td>
        <td>{% if far_is_upper_limit %} &lt; {% endif %}{{ display_far|scientific }}</td>
        <td>{% if far_is_upper_limit %} &lt; {% endif %}{{ display_far_hr }}</td>
        <td>{{ superevent.t_start }}</td>
        <td>{{ superevent.t_0 }}</td>
        <td>{{ superevent.t_end }}</td>
        <td>{{ superevent.created|multiTime:"superevent_created" }}</td>
        <td><a href="{% url "superevents:file-list" superevent.superevent_id %}">Data</a></td>
    </tr>
</table>